#include "windows.h"
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>

#include "ps2000.h"

#include "util.h"

#define CAPTURE_LENGTH 8000

/*#define MAX(a,b) ((a > b) ? a : b)
#define MIN(a,b) ((a < b) ? a : b)*/

int main(int argc, char *argv[]) {
	short handle, timebase, oversample = 1, time_units, overflow;
	long time_interval, max_samples, time_indisposed_ms;
	short capture_buffer[CAPTURE_LENGTH];
	int i, coverage, filter_level;
	char level_conv[65536];
	
	if(argc < 5) {
		printf("Usage: analyze <levels_file> <coverage-%%> <filter-level> <timebase>\n");
		printf("Example: analyze levels.txt 80 2 5\n");
		return -1;
	}
	
	coverage = atoi(argv[2]);
	filter_level = atoi(argv[3]);
	timebase = atoi(argv[4]);
	
	load_levels(argv[1], level_conv, coverage);
		
	handle = ps2000_open_unit();
	
	ps2000_set_channel(handle, PS2000_CHANNEL_A, TRUE, 1, PS2000_500MV);
	ps2000_set_channel(handle, PS2000_CHANNEL_B, TRUE, 1, PS2000_500MV);
	
	// No trigger
	ps2000_set_trigger(handle, PS2000_NONE, 0, PS2000_RISING, 0, 0);
	
	// Trigger on rising voltage on channel B
	//ps2000_set_trigger(handle, PS2000_CHANNEL_B, 8000, PS2000_RISING, -1, 10000);
	
	ps2000_get_timebase(handle, timebase, CAPTURE_LENGTH, 
		&time_interval, &time_units, oversample, &max_samples);

	fflush( stdin );
	
	ps2000_run_block(handle, CAPTURE_LENGTH, timebase, oversample, &time_indisposed_ms);

	while (!ps2000_ready(handle))
		Sleep(100);

	ps2000_get_values(handle, capture_buffer, NULL, NULL, NULL, &overflow, CAPTURE_LENGTH);
		
	ps2000_stop(handle);

	ps2000_close_unit(handle);
	
	for(i=0; i<CAPTURE_LENGTH; i++)
		capture_buffer[i] = level_conv[capture_buffer[i]+32768];
		
	clean_signal(capture_buffer, CAPTURE_LENGTH, filter_level);

	save_ols("output.osc", capture_buffer, CAPTURE_LENGTH, 500000); // pretend it's 500 kHz
	//save_sump("output1.sla", capture_buffer, CAPTURE_LENGTH, 500000); // pretend it's 500 kHz
	
	return 0;
}
