#ifndef __UTIL_H
#define __UTIL_H

// Save levels into a text file - generates 16 levels from 5 measured
// levels (0000, 0001, 0010, 0100, 1000) using binary math
void save_levels(char *filename, short *levels);

// Load levels from a text file, and create a level conversion 
// lookup table based on those values and given coverage.
// The coverage value is given as percentage, i.e. 80 for 80 %.
void load_levels(char *filename, char *level_conv, int coverage);

// replace -1 with last/next valid value as well as 
// "glitches" repeated less than <filter_level> times
void clean_signal(short *values, int len, int filter_level);

void save_sump(char *filename, short *values, int len, int rate);

void save_ols(char *filename, short *values, int len, int rate);

#endif